#include "utils.PRO2"
#include <list>


//l.size()> 0
bool emitjord(const list<int> &l){
  list<int>::const_iterator it=l.begin();
  bool b= true;
  int s = *it;
  int i=1;
  it++;
  //Inv: l fins l'anterior a it està mitjanament ordenada;
  //     si !b llavors l'element que està a it no és mitjanament ordenat
  //     s = "suma d'l fins l'anterior a it"
  //     i = "nombre d'elements d'l fins l'anterior a it"
  //     it és un elem de la llista o l.end()
  while (it !=l.end() and b){
    if (*it< s/i) b=false;
    else {
      s +=*it; // s= "suma d'l fins a it (inclós)"
      ++i;     // i = "nombre d'elements d'l fins a it"
      ++it;
    }
  }
  //Postw: b= "l està mitjanament ordenada"
  return b;
}
//Post: retorna si l està mitjanament ordenada o no


/*
Justificació:

1) Inicialitzacions:

Primer, tenim que l fins el primer element està mitjanament ordenada ja
que només n'hi ha un.  Com que b és cert és satisfà la segona
condició, com que s conté el primer element i "i" és 1, tenim la suma
i la longitud de l fins l'anterior a it (que apunta al següent del
primer).

2) Cos del bucle:

La condició del bucle ens garanteix que it!=l.end() i que "b" és
cert. En aquest cas del invariant tenim que l fins l'anterior a it
està mitjanament ordenada, que s = "suma de l fins l'anterior a it" i
que i= "nombre d'elements d'l fins l'anterior a it". Considerem els
dos casos:

 a) Si *it< s/i, és a dir l'ement apuntat per it és menor que la
 mitjana dels "i" anteriors, llavors l'element que està a "it" no és
 mitjanament ordenat i per tant, si posem "b" a fals és satisfà
 l'invariant.

 b) Si *it>= s/i llavors com que l'element que està a "it" és
 mitjanament ordenat tenim que l està mitjanament ordenada fins it
 (inclós) i cals incrementar "s" amb *it perquè contingui "suma de
 fins it" i incrementar "i" perquè contingui el nombre d'elements que
 hi ha fins a it. Despés d'això, podem abançar "it" per tornar a
 satisfer l'invariants ja que "b" segueix sent cert.

3) Condició de sortida:

Existeixen dos casos de sortida:

 a) i = l.end(). Per l'invariant tenim que l fins l'anterior a l.end()
 està mitjanament ordenada, és a dir, "l" està mitjanament ordenada i,
 per tant (també per l'invariant), "b" és cert, cosa que satisfà la
 postcondició.

 b) b és fals. Per l'invariant, tenim que l'element que està a it no
 és mitjanament ordenat i, per tant, "l" no està mitjanament ordenada,
 cosa que satisfà la postcondició, ja que "b" és fals.

4) Acabament:

Decreix la distància entre it i l.end()

 */


int main(){

  int n;
  cin >> n;
  
  list<int> l;
  list<int>::iterator it=l.end();
  for (int i=0; i<n; ++i) {
    int m;
    cin >> m;
    l.insert(it,m);
  }
  if (emitjord(l)) cout << "És mitjanament ordenada" << endl;
  else cout << "No és mitjanament ordenada" << endl;

}


/*
6
3 5 4 8 4 7
No és mitjanament ordenada
*/

/*
6
3 5 4 8 5 7
És mitjanament ordenada
*/
